`include "fifo_par_dp_ram.v"
`include "fifo_par_r.v"

module fifo_par (clk, rst, wen, ren, data, q, empty, full,amntt);

//------Parameters declaration:---------
	parameter  ADDRS   = 4;
	parameter  WIDTH   = 8;
//--------------------------------------

 //-----External signal declaration-----
	input    [WIDTH-1:0]  data;
	input                 clk;
	input                 rst;
	input                 wen;
	input                 ren;

	output   [WIDTH-1:0]  q;
	output                empty;
	output                full;
//---------------------------------------

 //----internal signal declaration------
	wire      [ADDRS-1:0]  wa;
	wire      [ADDRS-1:0]  ra;
//---------------------------------------
output    [ADDRS:0] amntt;
//---------------------------------------
	wire   [WIDTH-1:0]  q_int;
	wire                empty_int;
	wire                full_int;
//---------------------------------------

//---------------------------------------
	reg   [WIDTH-1:0]  q_int_reg;
	reg                empty_int_reg;
	reg                full_int_reg;
//---------------------------------------

	fifo_par_r #(ADDRS,WIDTH) fifo_r (
		.clk(clk),
		.rst(rst),
		.wen(wen),
		.ren(ren), 
		.waddr(wa), 
		.raddr(ra), 
		.full(full_int), 
		.empty(empty_int),
		.amntt(amntt)	
		
		);
//---------------------------------------

//---------------------------------------
	fifo_par_dp_ram #(ADDRS,WIDTH) dp_ram (
		.data_i(data),
		.clk(clk),
		.rst(rst),
		.wen(wen),
		.ren(ren), 
		.waddr(wa),
		.raddr(ra),
		.data_o(q_int),
		.amnt(amntt)
		);


always @ (posedge clk or posedge rst)
begin
  if(rst) begin
	  q_int_reg     = 0;
 	//  empty_int_reg = 1;
  	//  full_int_reg  = 0;
  end
  else 	begin
	//q_int_reg     = q_int;
	//empty_int_reg = empty_int;
	//full_int_reg  = full_int;	
  end
end

assign q=q_int;
assign empty=empty_int;
assign full=full_int;
endmodule
	




















