/** @file fifo_coverage.h
 *     .
 *
 * @author   (chupilko@ispras.ru)
 */

#pragma once

#include <hw/model.hpp>
#include <ts/coverage.hpp>
#include <tracer/tracer.hpp>

using namespace cpptesk::ts;
using namespace cpptesk::hw;
using namespace cpptesk::tracer;
using namespace cpptesk::tracer::coverage;

namespace cpptesk {
namespace examples {
namespace fifo {

///     .
class FIFO;

///     .
class FIFOCoverage {
public:
    FIFOCoverage(FIFO &fifo): fifo(fifo) {}

    ///  .
    CoverageTracker coverageTracker;

    ///     .
    DEFINE_ENUMERATED_COVERAGE(FIFO_FULNESS, "FIFO fulness", (
                                      (I0, "0 (free)"),
                                      (I1, "1"),
                                      (I2, "2"),
                                      (I3, "3"),
                                      (I4, "4"),
                                      (I5, "5"),
                                      (I6, "6"),
                                      (I7, "7"),
                                      (I8, "8"),
                                      (I9, "9"),
                                      (I10, "10"),
                                      (I11, "11"),
                                      (I12, "12"),
                                      (I13, "13"),
                                      (I14, "14"),
                                      (I15, "15"),
                                      (I16, "16 (full)")
                                  ));

    ///          .
    FIFO_FULNESS cov_FF(void) const;

    ///   .
    void out_cov_FF(void);

protected:
    ///    .
    FIFO &fifo;
};

}}}

